/**
 * @file  UrmUtility-oss.h
 * @brief UrmŎgputilityQpheader OSSp
 * 
 * 
 * @author      yuji.takayama@sony.com
 * @date        2019.08.14
 * @version     0.0
 * @copyright   2018-2019 Sony Corp. All rights reserved.
 * 
 * @par ύX:
 * - 2019.08.14: yuji.takayama@sony.com: VK쐬
 * - 2019.09.20: yuji.takayama@sony.com: ncftp putQƗp__NO_URM_CMD__ǉ
 * - 2019.10.01: yuji.takayama@sony.com: urmfastsysmngdf[ǉ
 *                                     : UrmSystem̌ʂ̃t@Cindexoptionǉ
 * - 2019.10.06: yuji.takayama@sony.com: UrmSystem̎sOdebug[h̎cURM_SYSTEM_LOG_DBGtOǉ
 *                                     : msgid̂ƂƂȂt@Cthreadl`ɕύX
 * - 2019.10.08: yuji.takayama@sony.com: ftok̂ƂɂȂt@Cthreadl̃t@CɕύX
 * - 2019.10.11: yuji.takayama@sony.com: FlistXV񐔎擾֐ǉ
 * - 2019.10.16: yuji.takayama@sony.com: UrmSystem֐̌ʏo̓t@CPID݂̂Ă̂TID悤ɕύX
*/


#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <sys/msg.h>
#include <sys/syscall.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdint.h>
#include <syslog.h>
#include <string.h>
#include <time.h>
#include <limits.h>
#include <errno.h>
#include <fcntl.h>
#include <spawn.h>
#include <wait.h>
#include "ftp_common.h"
#include "shmcom.h"
#include "common.h"
#ifndef __NO_URM_CMD__
#include "dpm.h"
#include "commands.h"
#endif

#ifndef URM_UTILITY_OSS_H_DEF
#define URM_UTILITY_OSS_H_DEF

#define MSG_TMP_FILE "/share/tmp/msg%s-%X-%lX"
#define SYSTEM_TMP_FILE "/share/tmp/system-tmp-%X-%lX"
#define SYSTEM_TMP_FILE_INDEX "/share/tmp/system-tmp-%X-%lX-%X-%X"
#define URMSYSTEM_OPT_SIZE		3
#define URMSYSTEM_OPT_INIT(X)	{X,0,0}

// For MsgBuf Queue pointer Replace
#define MsgBufConv(type,target)   \
              ( sizeof(type) > sizeof(MsgBuf) ) ? NULL : (type *)target \

// For Debug Msg File name
#define __FILENAME__	(strrchr(__FILE__,'/')?strrchr(__FILE__,'/')+1:__FILE__)

#ifdef DBGPRINT
/* NOT SEND TO SYSLOG */
#define UrmErrPrint(fmt,...)	printf("ERR:(%s:%d)"fmt"\n",__FILENAME__,__LINE__,##__VA_ARGS__)
#define UrmInfPrint(fmt,...)	printf("INF:(%s:%d)"fmt"\n",__FILENAME__,__LINE__,##__VA_ARGS__)
#define UrmDbgPrint(fmt,...)	printf("DBG:(%s:%d)"fmt"\n",__FILENAME__,__LINE__,##__VA_ARGS__)

#else
#define UrmErrPrint(fmt,...)	syslog(LOG_ERR  ,"(%06ld:%s:%d)"fmt,cur_usec(),__FILENAME__,__LINE__,##__VA_ARGS__)
#define UrmInfPrint(fmt,...)	syslog(LOG_INFO ,"(%06ld:%s:%d)"fmt,cur_usec(),__FILENAME__,__LINE__,##__VA_ARGS__)
// UrmDbgPrintOɎcɂ
// /etc/syslog-startup.confLOGLEVEL=8ɂ
// /etc/init.d/syslog restart
#define UrmDbgPrint(fmt,...)	syslog(LOG_DEBUG,"(%06ld:%s:%d)"fmt,cur_usec(),__FILENAME__,__LINE__,##__VA_ARGS__)
#endif


/*! @struct eDpmMutexArea
    @brief  Dpm Mutex Area enum
*/
typedef enum{
	eMutexNone = 0 ,
	eMutexHeader,
	eMutexSys2ToSys1,
	eMutexSys1ToSys2,
	eMutexSys2Sts,
	eMutexSys1Sts,
	eMutexFlist,
	eMutexMenu,
	eMutexLogSysCon,
	eMutexLogDevCon,
	eMutexEtc,
	eMutexAreaMax,
} eDpmMutexArea;

// For TimeOutCheck

/*! @struct TimeOUtcheck_t
    @brief  TimeOutp̍\
*/
typedef struct TIME_OUT_CHECK{
	int wait_flag;
	struct timespec start;
	struct timespec now;
	uint64_t timeout; // u second
}TimeOutCheck_t;
int TimeOutCheck(TimeOutCheck_t *t);
void ResetTimeOut(TimeOutCheck_t *t);
void StartTimeOut(TimeOutCheck_t *t,uint64_t timeout);

#define TIMEOUT_OCCURED		(1)
#define TIMEOUT_RUNNING		(0)
#define TIMEOUT_NOT_RUNNING	(2)
#define	TIMEOUT_1MS			     (1000)
#define	TIMEOUT_10MS		    (10000)
#define TIMEOUT_100MS		   (100000)
#define TIMEOUT_1SEC		  (1000000)
#define TIMEOUT_5SEC		  (5000000)
#define TIMEOUT_10SEC		( 10000000)
#define TIMEOUT_20SEC		( 20000000)
#define TIMEOUT_30SEC		( 30000000)
#define TIMEOUT_3MIN		(180000000)
#define TIMEOUT_1MIN		 (60000000)
#define TIMEOUT_10MIN       (600000000)

// For UrmSystemOptions
#define URM_SYSTEM_CHILD_PIPE		(0x00000001)
#define URM_SYSTEM_OUTPUT_FILE		(0x00000002)
#define URM_SYSTEM_OUTPUT_FILE_INDX (0x00000004) /* put int val[3]; structure */
#define URM_SYSTEM_LOG_DBG			(0x08000000)

// for share memory and semaphore
typedef enum{
	eShmCreateAndAttach,
	eShmAttach,
}eShmAttachMode;
typedef enum{
	eShmDeattachAndDelete,
	eShmDeattach,
}eShmDeattachMode;

#define EXIT_SEM_EXIST
#define EXIT_SEM_FAIL			(-1)
#define EXIT_SEM_SUCCESS		(0)
#define SEM_CREATE_AND_GET		(1)
#define SEM_GET					(0)
#define SEM_RELEASE_AND_DELE	(1)
#define SEM_RELEASE				(0)

/*! @struct  eUrmMsgSndDst
    @brief  Msgenum
*/
typedef enum {
	eMsgSyscomd,
	eMsgFilelistd,
	eMsgSystemMngd,
	eMsgEmmcd,
	eMsgFastSysMngd,
} eUrmMsgSndDst;
/*! @struct  UrmPid_t
    @brief  pid set
*/
typedef struct{
	int  pid;
	long tid;
}UrmPid_t;



// For UrmSystem
#define URM_SYSTEM_ARG_BUF	(4096)
#define URM_SYSTEM_ARG_NUM	(128)
#define URM_SYSTEM_BUF		(1024)
#define URM_SYSTEM_STR_SIZE	(URM_SYSTEM_BUF -1)
int UrmSystem(const char *PathToCmd, 
			  char *CmdArg, 
			  int *err_flag,
			  int *opt,
			  const char *CallerFile,
			  int CallerLine);

#define UrmWrite(fd,buf, count) UrmUtilWrite(fd,buf,count,__FUNCTION__,__LINE__)
#define UrmRead(fd, buf, count)	UrmUtilRead(fd, buf, count,__FUNCTION__,__LINE__)

long cur_usec(void);
ssize_t UrmUtilWrite(int fd, const void *buf, size_t count,const char *filename,int line);
ssize_t UrmUtilRead(int fd, void *buf, size_t count,const char *filename,int line);
int UrmFileNameConvFtpExt2Internal(char *src_file,char *out_file,int size,uid_t uid);
int UrmFileNameConvInternal2FtpExt(char *src_file,char *out_file,int size,uid_t uid);
int GetFileFullPath(char *in_filename,char *out_filename,size_t len,char *virt_path);
int UrmGetAliasInfo(struct NasAliasInfo *NasInfo,char *aliasname);
int UrmGetAliasName(char *fullpath, char *aliasname, int size,struct NasAliasInfo *NasInfo);
char *UrmShmCreateAndAttach(const char *fid,char id ,eShmAttachMode create, uint64_t size, int *shmid, char *message);
int UrmShmDeattachAndDelete(char *shm ,int shmid ,eShmDeattachMode deleflag ,char *message);
char * UrmShareMemoryInit (int *shmid,UrmPid_t pid,eShmAttachMode create,int size,char *msg);
int UrmShareMemoryRelease(char *shm,int shmid,UrmPid_t pid,eShmDeattachMode deleteflag,char *msg);
int UrmIsAtoiOk(char *p);
int UrmIpcMutexCreateAndGet(const char *fileid,char id,int create,char *message);
int UrmIpcMutexReleaseAndDelete (int semid , int deleteflag , char *message);
int UrmRmSyscomRcvMsgid(int msgid,char *dbgmsg);
int UrmRmFlistmngRcvMsgid(int msgid,char *dbgmsg);
int UrmRmSysmngRcvMsgid(int msgid,char *dbgmsg);
int UrmRmEmmcdRcvMsgid(int msgid,char *dbgmsg);
int UrmRmRcvMsgid(int msgid,eUrmMsgSndDst dst,char *dbgmsg);
int UrmMsgSnd(eUrmMsgSndDst dst,char *sndbuf, size_t sndsize,char *msg);
int UrmMsgRcv(int msgid,char *rcvbuf,size_t rcvsize,char *msg);
int UrmIpcMakeKey ( const char *pathname, int id, key_t *key,int line);
#ifndef __NO_URM_CMD__
#define UrmInitCmdHdr(p,msgid,cmdid,len)	 UrmUtilInitCmdHeader(p,msgid,cmdid,len,__FILENAME__,__LINE__)
void UrmUtilInitCmdHeader(struct CmdHeader *mHd,uint32_t msgid,uint32_t cmdid,uint32_t len,char *func,int line);
#endif
int UrmGetSyscomRcvMsgid(void);
int UrmGetFlistmngRcvMsgid(void);
int UrmGetSysmngRcvMsgid(void);
int UrmGetEmmcdRcvMsgid(void);
int UrmGetRcvMsgid(eUrmMsgSndDst msg);
int StringSplitter(char *str, int num, char *retbuf, int size);
uint32_t UrmGetFlistUpdateCnt(void);

#endif //URM_UTILITY_OSS_H_DEF