/**
 * @file  urm_main.h
 * @brief vsftp urm proc main header
 * 
 *  NOTICE : 
 * 
 * @author      yuji.takayama@sony.com
 * @date        2018.08.08
 * @version     0.0
 * @copyright   2018 Sony Corp. All rights reserved.
 * 
 * @par ύX:
 * - 2018.08.8: yuji.takayama@sony.com : VK쐬
 * - 2019.01.15: yuji.takayama@sony.com : handle_retr_urm̃IvVǉ(SITE STBF)
 * - 2019.02.08: yuji.takayama@sony.com: 
 *             vsf_access_check_file_urm
 *             vsf_sysutil_getcwd_urm
 *             vsf_sysutil_chdir_urmǉ
 * - 2019.03.12: yuji.takayama@sony.com: urm_infolog/urm_errlogp~
 * - 2019.04.10: yuji.takayama@sony.com: urmpfile_open,dir_openǉ
 * - 2019.04.24: yuji.takayama@sony.com: Get the transfer job statusΉ
 * - 2019.05.17: yuji.takayama@sony.com: RETR optionenumɕύX
 * - 2019.06.04: yuji.takayama@sony.com: Alias LIST Ή
 * - 2019.07.01: yuji.takayama@sony.com: vsf_access_check_file_urmNAS̎log in,dir̗L̃`FbN
 * - 2019.08.05: yuji.takayama@sony.com: urmftp-pipe
 * - 2019.10.11: yuji.takayama@sony.com : vsf_access_check_file_urmUSB}EgtOǉ
 */

#include "../../common/ftp_common.h"
#include "../../common/UrmUtility-oss.h"
#include "../../common/common.h"
#include "../../common/shmcom.h"

#ifndef URM_MAIN_H_DEF
#define URM_MAIN_H_DEF

// users define
#define USER_ROOT			"root"
#define USER_USER			"user"
#define USER_MAINTENANCE	"maintenance"
// user code
#define	USER_CODE_UNDEF	(-1)
#define USER_CODE_ROOT	(1)
#define	USER_CODE_USER	(0)

// urm_main return values
#define URM_MAIN_RET_ERROR      (2)
#define URM_MAIN_RET_DONE		(1)		//urm_main execute command
#define URM_MAIN_RET_CONTINUE	(0)		//urm_main does not process anything. 
#define URM_MAIN_RET_UNDEF		(-1)

#define STAT_BIN_FILE		"/share/filelist/stat.bin"


#define PLST_CMD_FILE	 PLST_DIR "cmd%X-%lX"
#define PLST_RET_FILE	 PLST_DIR "ret%X-%lX"


enum{
 URM_RETR_OPTION_MXF,
 URM_RETR_OPTION_MXF_REPF,
 URM_RETR_OPTION_STBF,
 URM_RETR_OPTION_DF,
 URM_RETR_OPTION_RTJC_STATUS,
 URM_RETR_OPTION_ALIAS_LIST,
 URM_RETR_OPTION_PLST,
};

#define	VSF_ACCESS_SUCCESS			(1)
#define	VSF_ACCESS_FAIL				(0)
#define VSF_ACCESS_FAIL_AILAS_LOGIN	(-1)
#define VSF_ACCESS_FAIL_URM			(-2)
#define VSF_ACCESS_EXIST_FULL		(0)
#define VSF_ACCESS_EXIST_DIR		(1)

#define VSF_USB_MOUNT_ON      (1)
#define VSF_USB_MOUNT_OFF     (0)

struct vsf_session;

int urm_main(struct vsf_session *p_sess);
char * urm_share_memory_init(int *shmid,int size );
int urm_share_memory_release(char *shm,int shmid );
//void urm_errlog(const char *format, ...);
//void urm_infolog(const char *format, ...);
struct vsf_transfer_ret vsf_ftpdataio_transfer_file_urm
      (struct vsf_session* p_sess, int remote_fd,int file_fd, int is_recv, int is_ascii);

int getpid_urm(void);
int urm_share_memory_data_splitter(char *shm, int *ret_code, char *ret_mess, char *data, int data_size);
int vsf_access_check_file_urm(const struct mystr* p_filename_str,int exist_mode,int UsbMountFlg);
char *vsf_sysutil_getcwd_urm(char *p_dest, const unsigned int  buf_size);
int vsf_sysutil_chdir_urm(const char* p_dirname);
int urm_flistmngd_mutex_lock(void);
int urm_flistmngd_mutex_unlock(int sem_id);
int str_rename_urm(const struct mystr* p_from_str,const struct mystr* p_to_str, struct vsf_session* p_sess);
int str_unlink_urm(const struct mystr* p_str, struct vsf_session* p_sess);
struct vsf_sysutil_dir* str_opendir_urm (const struct mystr* p_str);
int vsf_sysutil_open_file_urm ( const char* p_filename,const enum EVSFSysUtilOpenMode);
int UrmFtpPipe (char *cmd);
void ExecuteUrmFtpPipe(int pipe00,int pipe01,int pipe10,int pipe11);
#endif  // URM_MAIN_H_DEF
